<template>
    <div v-if="textEditor">
        <Discount
            :data="textEditor"
            @checkChanged="checkChanged"
        />
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Preview</b>
                </div>
                <div class="col-md-8 text-right">
                    <b-select
                        v-model="selectedTagMenu"
                        class="form-control select-tags"
                        @change="addText"
                    >
                        <option
                            v-for="(menu, index) in previewTags"
                            :key="index"
                            :value="menu.title"
                            :disabled="menu.title === 'tags'"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
            </div>
            <validation-provider
                v-slot="validationContext"
                name="Subject"
                rules="required"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Subject</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.subject"
                        type="text"
                        name="subject"
                        :state="getValidationState(validationContext)"
                        class="my-input full-width"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Email Preview"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Email Preview</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.pre_header"
                        type="text"
                        class="my-input full-width"
                        name="pre_header"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
        </div>
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Email Content</b>
                </div>
                <div class="col-md-8 text-right">
                    <b-select
                        v-model="selectedTagMenu"
                        class="form-control select-tags"
                        @change="addText"
                    >
                        <option
                            v-for="(menu, index) in tags"
                            :key="index"
                            :value="menu.title"
                            :disabled="menu.title === 'tags'"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
            </div>
            <validation-provider
                v-slot="validationContext"
                name="Header"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Header</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.title"
                        type="text"
                        class="my-input full-width"
                        name="title"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Before Cart Body Text"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Before Cart Body Text</b>
                    </div>
                    <b-form-textarea
                        v-model="textEditor.paragraph_1"
                        class="form-control full-width my-text-area"
                        name="paragraph_1"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="After Cart Body Text"
                :rules="{ required: false }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>After Cart Body Text</b>
                    </div>
                    <b-form-textarea
                        v-model="textEditor.paragraph_2"
                        class="my-input full-width my-text-area"
                        name="paragraph_2"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Footer"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Footer</b>
                    </div>
                    <b-form-textarea
                        v-model="textEditor.footer"
                        type="text"
                        class="my-input full-width my-text-area"
                        name="footer"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Footer"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Unsubscribe confirmation</b>
                    </div>
                    <b-form-textarea
                        v-model="textEditor.unsubscribe_confirmation"
                        type="text"
                        class="full-width my-text-area"
                        name="Unsubscribe confirmation"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    >
                        {{ textEditor.unsubscribe_confirmation }}
                    </b-form-textarea>
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
        </div>

        <!--    Cart   -->
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Cart</b>
                </div>
                <div class="col-md-8 text-right">
                    <b-select
                        v-model="selectedTagMenu"
                        class="form-control select-tags"
                        @change="addText"
                    >
                        <option
                            v-for="(menu, index) in tags"
                            :key="index"
                            :value="menu.title"
                            :disabled="menu.title === 'tags'"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
            </div>
            <div class="row cart-row-container">
                <div class="col-md-6">
                    <validation-provider
                        v-slot="validationContext"
                        name="Cart title"
                        :rules="{ required: true }"
                    >
                        <b-form-group class="full-width">
                            <div class="cart-subtitle">
                                Cart title
                            </div>
                            <b-form-input
                                v-model="textEditor.cart_offer_texts.cart_offer_left"
                                :state="getValidationState(validationContext)"
                                name="cart_offer_texts.cart_offer_left"
                                type="text"
                                class="my-input full-width"
                                @click="focus"
                                @blur="checkChanged"
                            />
                            <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                        </b-form-group>
                    </validation-provider>
                </div>
                <div class="col-md-6">
                    <validation-provider
                        v-slot="validationContext"
                        name="Product Description Column Text"
                        :rules="{ required: true }"
                    >
                        <b-form-group class="full-width">
                            <div class="cart-subtitle">
                                Product Description Column Text
                            </div>
                            <b-form-input
                                v-model="textEditor.cart_offer_texts.cart_offer_product_description"
                                name="cart_offer_texts.cart_offer_product_description"
                                type="text"
                                :state="getValidationState(validationContext)"
                                class="my-input full-width"
                                @click="focus"
                                @blur="checkChanged"
                            />
                            <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                        </b-form-group>
                    </validation-provider>
                </div>
            </div>
            <div class="row cart-row-container">
                <div class="col-md-6">
                    <validation-provider
                        v-slot="validationContext"
                        name="Product Price Column Text Title"
                        :rules="{ required: true }"
                    >
                        <b-form-group class="full-width">
                            <div class="cart-subtitle">
                                Product Price Column Text Title
                            </div>
                            <b-form-input
                                v-model="textEditor.cart_offer_texts.cart_offer_product_price"
                                name="cart_offer_texts.cart_offer_product_price"
                                type="text"
                                :state="getValidationState(validationContext)"
                                class="my-input full-width"
                                @click="focus"
                                @blur="checkChanged"
                            />
                            <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                        </b-form-group>
                    </validation-provider>
                </div>
                <div class="col-md-6">
                    <validation-provider
                        v-slot="validationContext"
                        name="Product Quantity Column Text"
                        :rules="{ required: true }"
                    >
                        <b-form-group class="full-width">
                            <div class="cart-subtitle">
                                Product Quantity Column Text
                            </div>
                            <b-form-input
                                v-model="textEditor.cart_offer_texts.cart_offer_product_qty"
                                :state="getValidationState(validationContext)"
                                name="cart_offer_texts.cart_offer_product_qty"
                                type="text"
                                class="my-input full-width"
                                @click="focus"
                                @blur="checkChanged"
                            />
                            <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                        </b-form-group>
                    </validation-provider>
                </div>
            </div>
            <div class="row cart-row-container">
                <div class="col-md-6">
                    <validation-provider
                        v-slot="validationContext"
                        name="Product Total Column Text"
                        :rules="{ required: true }"
                    >
                        <b-form-group class="full-width">
                            <div class="cart-subtitle">
                                Product Total Column Text
                            </div>
                            <b-form-input
                                v-model="textEditor.cart_offer_texts.cart_offer_product_total"
                                :state="getValidationState(validationContext)"
                                name="cart_offer_texts.cart_offer_product_total"
                                type="text"
                                class="my-input full-width"
                                @click="focus"
                                @blur="checkChanged"
                            />
                            <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                        </b-form-group>
                    </validation-provider>
                </div>
                <div class="col-md-6">
                    <validation-provider
                        v-slot="validationContext"
                        name="Cart Total Text"
                        :rules="{ required: true }"
                    >
                        <b-form-group class="full-width">
                            <div class="cart-subtitle">
                                Cart Total Text
                            </div>
                            <b-form-input
                                v-model="textEditor.cart_offer_texts.cart_offer_total"
                                :state="getValidationState(validationContext)"
                                name="cart_offer_texts.cart_offer_total"
                                type="text"
                                class="my-input full-width"
                                @click="focus"
                                @blur="checkChanged"
                            />
                            <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                        </b-form-group>
                    </validation-provider>
                </div>
            </div>
            <validation-provider
                v-slot="validationContext"
                name="Button text"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="cart-subtitle">
                        Button text
                    </div>
                    <b-form-input
                        v-model="textEditor.button_text"
                        :state="getValidationState(validationContext)"
                        name="button_text"
                        type="text"
                        class="my-input full-width"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
        </div>
    </div>
</template>

<script>
import { tags } from '@/mixins/add-tags.js'
import Discount from '@/components/edit/Discount.vue'
import {emailTags, emailPreviewTags} from '@/store/constants.js'

export default {
    name: "BrowseTextEditor",
    components: {
        Discount
    },
    mixins: [tags],
    props: ['textEditor', 'oldTextEditor', 'edited', 'submit'],
    data: () => ({
        tags: emailTags,
        previewTags: emailPreviewTags,
        selectedTagMenu: 'tags',
        focusedInput: 0,
        focusedName: '',
        submitted: false
    }),
    watch: {},
    methods: {
        addText() {
            const data = this.addTag(this.textEditor, this.focusedName, this.focusedInput, this.selectedTagMenu)

            if(data.keys.length > 1) this.textEditor[data.keys[0]][data.keys[1]] = data.value
            else this.textEditor[data.keys[0]] = data.value
            
            this.focusedInput += this.selectedTagMenu.length
            this.selectedTagMenu = 'tags'
        },
        checkChanged(key) {
            this.$emit('checkChanged', key)
        },
        getValidationState({dirty, validated, valid = null}) {
            return dirty || validated ? valid : null;
        },
        focus(e) {
            this.focusedInput = e.target.selectionStart
            this.focusedName = e.target.name
        },
    }
}
</script>

<style scoped lang="scss">


</style>
